if not defined GMIO_BUILD_ROOT (
    echo "****ERROR: Variable GMIO_BUILD_ROOT not defined"
    exit 0
)

@set BUILD_TYPE=%1
@set VSXXXCOMNTOOLS=%~2
@set TARGET_ARCH=%3

@set INCLUDE=
@set LIB=
@set LIBPATH=
@set VS80COMNTOOLS=
@set VS90COMNTOOLS=
@set VS100COMNTOOLS=
@set VS110COMNTOOLS=
@set VS120COMNTOOLS=
@set VS140COMNTOOLS=
@set VSINSTALLDIR=
@set Framework35Version=
@set FrameworkDir=
@set FrameworkVersion=
@set FrameworkDir32=
@set FrameworkVersion32=
@set FrameworkDir64=
@set FrameworkVersion64=
@set WindowsSdkDir=
call "%VSXXXCOMNTOOLS%\..\..\VC\vcvarsall.bat" %TARGET_ARCH%
@set VSXXXCOMNTOOLS=

if "%ROOTDIR_OPENCASCADE%"=="" (
    set BUILD_BENCHMARK_OPENCASCADE=OFF
) else (
    set BUILD_BENCHMARK_OPENCASCADE=ON
)

@set BUILD_OUTPUT_FILE=%GMIO_BUILD_ROOT%\%CURRENT_BUILD%_%BUILD_TYPE%.txt 2>&1
cd %GMIO_BUILD_ROOT%\%CURRENT_BUILD%\%BUILD_TYPE%
cmake %GMIO_ROOT% -G "NMake Makefiles" ^
      -DCMAKE_BUILD_TYPE=%BUILD_TYPE%  -DCMAKE_DEBUG_POSTFIX=_d ^
      -DCMAKE_INSTALL_PREFIX=%GMIO_BUILD_ROOT%\%CURRENT_BUILD%\install ^
      -DGMIO_FLOAT2STR_LIB=google_doubleconversion ^
      -DGMIO_BUILD_EXAMPLES=ON ^
      -DGMIO_BUILD_TESTS_FAKE_SUPPORT=ON ^
      -DGMIO_BUILD_BENCHMARKS=ON ^
      -DGMIO_BUILD_BENCHMARK_ASSIMP=ON -DROOTDIR_ASSIMP=%ROOTDIR_ASSIMP% ^
      -DGMIO_BUILD_BENCHMARK_OPENCASCADE=%BUILD_BENCHMARK_OPENCASCADE% ^
      -DROOTDIR_OPENCASCADE=%ROOTDIR_OPENCASCADE% ^
      -DGMIO_BUILD_BENCHMARK_LIB3MF=OFF ^
      > %BUILD_OUTPUT_FILE%
jom -j4 >> %BUILD_OUTPUT_FILE%
jom check >> %BUILD_OUTPUT_FILE%
jom install >> %BUILD_OUTPUT_FILE%
